module Middleman
  module Cli

    class DeployWithNotifications < Thor

      namespace :deploy

      protected

      desc "notify_airbrake", ""
      def notify_airbrake
        puts "Recording a timestamped deploy in Airbrake: #{self.deploy_options.revision_short}".green
        url = "api_key=#{self.deploy_options.airbrake_api_key}" +
          "&deploy[rails_env]=production" +
          "&deploy[local_username]=#{self.deploy_options.deploy_user}" +
          "&deploy[scm_repository]=git@github.com:140proof/280.140proof.com.git" +
          "&deploy[scm_revision]=#{self.deploy_options.revision_short}"
        `curl -d "#{url}" http://airbrake.io/deploys &> /dev/null`
      end

      desc "hipchat_start", ""
      def notify_hipchat_start
        send_hc_mesg( "#{exclaim} @#{self.deploy_options.deploy_user} is deploying #{self.deploy_options.github_project}:" )
      end
      remove_task :notify_hipchat_start

      desc "hipchat_complete", ""
      def notify_hipchat_complete
        puts "Notifying hipchat room(s)".yellow

        message =  "<a href='http://github.com/#{self.deploy_options.github_user}/#{self.deploy_options.github_project}/commit/#{self.deploy_options.revision}'>#{self.deploy_options.revision}</a> " +
          "(#{self.deploy_options.git_comment}) is now live on <b><a href='http://#{self.deploy_options.github_project}'>production</a></b>."
        send_hc_mesg(message, "html")
      end
      remove_task :notify_hipchat_complete

      def exclaim
        phrases = [
          "Holy cannoli",
          "Holy guacamole",
          "Holy hot chocolate",
          "Holy ravioli",
          "Hot buttery biscuits",
        ]
        return phrases[rand(phrases.size)] + "!"
      end
      remove_task :exclaim

      def send_hc_mesg(mesg, fmt = "text")
        uri = uri || URI.parse( "http://api.hipchat.com/v1/rooms/message" )
        puts mesg
        self.deploy_options.hipchat_rooms.each do |room|
          Net::HTTP.post_form( uri, {
            "auth_token"      => self.deploy_options.hipchat_token,
            "color"           => "random",
            "format"          => "json",
            "from"            => "280 Deploy",
            "message"         => mesg,
            "message_format"  => fmt || "text",
            "room_id"         => room,
            })
        end
      end
      remove_task :send_hc_mesg

    end

  end
end
